Lorene::Eos_poly Class Reference
Equations of state

Polytropic equation of state (relativistic case). More...

`#include <eos.h>`

Inheritance diagram for Lorene::Eos_poly:

## Public Member Functions

| Eos_poly (double gamma, double kappa)
| Standard constructor (sets both `m_0` and `mu_0` to 1).
| Eos_poly (double gamma, double kappa, double mass)
| Standard constructor with individual particle mass (sets `mu_0` to 1).
| Eos_poly (double gamma, double kappa, double mass, double mu_zero)
| Standard constructor with individual particle mass and zero-pressure chemical potential.
| Eos_poly (const Eos_poly &)
| Copy constructor.
virtual | ~Eos_poly ()
| Destructor.
void | operator= (const Eos_poly &)
| Assignment to another `Eos_poly`.
virtual bool | operator== (const Eos &) const
| Comparison operator (egality).
virtual bool | operator!= (const Eos &) const
| Comparison operator (difference).
virtual int | identify () const
| Returns a number to identify the sub-classe of `Eos` the object belongs to.
double | get_gam () const
| Returns the adiabatic index (cf. Eq. (3)).
double | get_kap () const
| Returns the pressure coefficient (cf.
double | get_m_0 () const
| Return the individual particule mass (cf.
double | get_mu_0 () const
| Return the relativistic chemical potential at zero pressure [unit: , with ].
virtual void | sauve (FILE *) const
| Save in a file.
virtual double | nbar_ent_p (double ent, const Param *par=0x0) const
| Computes the baryon density from the log-enthalpy.
virtual double | ener_ent_p (double ent, const Param *par=0x0) const
| Computes the total energy density from the log-enthalpy.
virtual double | press_ent_p (double ent, const Param *par=0x0) const
| Computes the pressure from the log-enthalpy.
virtual double | der_nbar_ent_p (double ent, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy.
virtual double | der_ener_ent_p (double ent, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy.
virtual double | der_press_ent_p (double ent, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy.
const char * | get_name () const
| Returns the EOS name.
void | set_name (const char *name_i)
| Sets the EOS name.
Cmp | nbar_ent (const Cmp &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the baryon density field from the log-enthalpy field and extra parameters.
Scalar | nbar_ent (const Scalar &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the baryon density field from the log-enthalpy field and extra parameters.
Cmp | ener_ent (const Cmp &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the total energy density from the log-enthalpy and extra parameters.
Scalar | ener_ent (const Scalar &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the total energy density from the log-enthalpy and extra parameters.
Cmp | press_ent (const Cmp &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the pressure from the log-enthalpy and extra parameters.
Scalar | press_ent (const Scalar &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the pressure from the log-enthalpy and extra parameters.
Cmp | der_nbar_ent (const Cmp &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy and extra parameters.
Scalar | der_nbar_ent (const Scalar &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy and extra parameters.
Cmp | der_ener_ent (const Cmp &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy and extra parameters.
Scalar | der_ener_ent (const Scalar &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy and extra parameters.
Cmp | der_press_ent (const Cmp &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy and extra parameters.
Scalar | der_press_ent (const Scalar &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy and extra parameters.

## Static Public Member Functions

static Eos * | eos_from_file (FILE *)
| Construction of an EOS from a binary file.
static Eos * | eos_from_file (ifstream &)
| Construction of an EOS from a formatted file.

## Protected Member Functions

| Eos_poly (FILE *)
| Constructor from a binary file (created by the function `sauve(FILE*)` ).
| Eos_poly (ifstream &)
| Constructor from a formatted file.
void | set_auxiliary ()
| Computes the auxiliary quantities `gam1` , `unsgam1` , `gam1sgamkap` from the values of `gam` and `kap`.
virtual ostream & | operator>> (ostream &) const
| Operator >>.
void | calcule (const Cmp &thermo, int nzet, int l_min, double(Eos::*fait)(double, const Param *) const, const Param *par, Cmp &resu) const
| General computational method for `Cmp` 's.
void | calcule (const Scalar &thermo, int nzet, int l_min, double(Eos::*fait)(double, const Param *) const, const Param *par, Scalar &resu) const
| General computational method for `Scalar` 's.

## Protected Attributes

double | gam
| Adiabatic index (cf. Eq. (3)).
double | kap
| Pressure coefficient (cf.
double | m_0
| Individual particule mass (cf.
double | mu_0
| Relativistic chemical potential at zero pressure [unit: , with ].
double | gam1
double | unsgam1
double | gam1sgamkap
double | rel_mu_0
double | ent_0
| Enthalpy at zero pressure ( ).
char | name [100]
| EOS name.

## Friends

Eos * | Eos::eos_from_file (FILE *)
| The construction functions from a file.
Eos * | Eos::eos_from_file (ifstream &)

## Detailed Description

Polytropic equation of state (relativistic case).

This equation of state (EOS) corresponds to identical relativistic particles of rest mass is , whose total energy density e is related to their numerical density n by

where is the chemical potential at zero pressure. The relativistic (i.e. including rest mass energy) chemical potential is then

The pressure is given by the (zero-temperature) First Law of Thermodynamics: , so that

The log-enthalpy is defined as the logarithm of the ratio of the enthalpy par particle by the partical rest mass energy :

According to the (zero-temperature) First Law of Thermodynamics, the log-enthalpy is related to the chemical potential by

From this expression and relation (2), the expression of the particle density in term of the log-enthalpy is

The energy density and pressure as functions of H can then be obtained by inserting this relation into Eqs. (1) and (3).

()

Definition at line 757 of file eos.h.

## Constructor & Destructor Documentation

## Eos_poly() [1/6]

Lorene::Eos_poly::Eos_poly | ( | double | gamma,
|  | double | kappa )

Standard constructor (sets both `m_0` and `mu_0` to 1).

The individual particle mass is set to the mean baryon mass .

Parameters

  gamma | adiabatic index (cf. Eq. (3))
  kappa | pressure coefficient (cf. Eq. (3)) [unit: ], where and

Definition at line 126 of file eos_poly.C.

References Lorene::Eos::Eos(), gam, kap, m_0, mu_0, and set_auxiliary().

## Eos_poly() [2/6]

Lorene::Eos_poly::Eos_poly | ( | double | gamma,
|  | double | kappa,
|  | double | mass )

Standard constructor with individual particle mass (sets `mu_0` to 1).

Parameters

  gamma | adiabatic index (cf. Eq. (3))
  kappa | pressure coefficient (cf. Eq. (3)) [unit: ], where and
  mass | individual particule mass (cf. Eq. (1) [unit: ]

Definition at line 136 of file eos_poly.C.

References Lorene::Eos::Eos(), gam, kap, m_0, mu_0, and set_auxiliary().

## Eos_poly() [3/6]

Lorene::Eos_poly::Eos_poly | ( | double | gamma,
|  | double | kappa,
|  | double | mass,
|  | double | mu_zero )

Standard constructor with individual particle mass and zero-pressure chemical potential.

Parameters

  gamma | adiabatic index (cf. Eq. (3))
  kappa | pressure coefficient (cf. Eq. (3)) [unit: ], where and
  mass | individual particule mass (cf. Eq. (1)) [unit: ]
  mu_zero | Relativistic chemical potential at zero pressure [unit: , with ]. (standard value: 1)

Definition at line 146 of file eos_poly.C.

References Lorene::Eos::Eos(), gam, kap, m_0, mu_0, and set_auxiliary().

## Eos_poly() [4/6]

Lorene::Eos_poly::Eos_poly | ( | const Eos_poly & | eosi | ) |

Copy constructor.

Definition at line 156 of file eos_poly.C.

References Lorene::Eos::Eos(), Eos_poly(), gam, kap, m_0, mu_0, and set_auxiliary().

## Eos_poly() [5/6]

Lorene::Eos_poly::Eos_poly | ( | FILE * | fich | ) |

protected

Constructor from a binary file (created by the function `sauve(FILE*)` ).

This constructor is protected because any EOS construction from a binary file must be done via the function `Eos::eos_from_file(FILE*)` .

Definition at line 167 of file eos_poly.C.

References Lorene::Eos::Eos(), Lorene::fread_be(), gam, kap, m_0, mu_0, and set_auxiliary().

## Eos_poly() [6/6]

Lorene::Eos_poly::Eos_poly | ( | ifstream & | fich | ) |

protected

Constructor from a formatted file.

This constructor is protected because any EOS construction from a formatted file must be done via the function `Eos::eos_from_file(ifstream&)` .

Definition at line 190 of file eos_poly.C.

References Lorene::Eos::Eos(), gam, kap, m_0, mu_0, and set_auxiliary().

## ~Eos_poly()

Lorene::Eos_poly::~Eos_poly | ( |  | ) |

virtual

Destructor.

Definition at line 215 of file eos_poly.C.

## Member Function Documentation

## calcule() [1/2]

void Lorene::Eos::calcule | ( | const Cmp & | thermo,
|  | int | nzet,
|  | int | l_min,
|  | double(Eos::* | fait )(double, const Param *) const,
|  | const Param * | par,
|  | Cmp & | resu ) const

protected inherited

General computational method for `Cmp` 's.

Parameters

  thermo | [input] thermodynamical quantity (for instance the enthalpy field)from which the thermodynamical quantity `resu` is to be computed.
  nzet | [input] number of domains where `resu` is to be computed.
  l_min | [input] index of the innermost domain is which `resu` is to be computed [default value: 0]; `resu` is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  fait | [input] pointer on the member function of class `Eos` which performs the pointwise calculation.
  par | possible extra parameters of the EOS
  resu | [output] result of the computation.

Definition at line 203 of file eos.C.

References Lorene::Cmp::annule(), Lorene::Valeur::c, Lorene::Valeur::coef_i(), Eos(), Lorene::Cmp::get_etat(), Lorene::Tbl::get_etat(), Lorene::Cmp::get_mp(), Lorene::Mg3d::get_nzone(), Lorene::Tbl::get_taille(), Lorene::Map(), Lorene::Valeur::set_etat_c_qcq(), Lorene::Cmp::set_etat_qcq(), Lorene::Mtbl::set_etat_qcq(), Lorene::Tbl::set_etat_qcq(), Lorene::Cmp::set_etat_zero(), Lorene::Tbl::set_etat_zero(), Lorene::Mtbl::t, Lorene::Tbl::t, and Lorene::Cmp::va.

## calcule() [2/2]

void Lorene::Eos::calcule | ( | const Scalar & | thermo,
|  | int | nzet,
|  | int | l_min,
|  | double(Eos::* | fait )(double, const Param *) const,
|  | const Param * | par,
|  | Scalar & | resu ) const

protected inherited

General computational method for `Scalar` 's.

Parameters

  thermo | [input] thermodynamical quantity (for instance the enthalpy field)from which the thermodynamical quantity `resu` is to be computed.
  nzet | [input] number of domains where `resu` is to be computed.
  l_min | [input] index of the innermost domain is which `resu` is to be computed [default value: 0]; `resu` is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  fait | [input] pointer on the member function of class `Eos` which performs the pointwise calculation.
  par | possible extra parameters of the EOS
  resu | [output] result of the computation.

Definition at line 268 of file eos.C.

References Lorene::Scalar::annule(), Lorene::Valeur::c, Lorene::Valeur::coef_i(), Eos(), Lorene::Scalar::get_etat(), Lorene::Tbl::get_etat(), Lorene::Tensor::get_mp(), Lorene::Mg3d::get_nzone(), Lorene::Scalar::get_spectral_va(), Lorene::Tbl::get_taille(), Lorene::Map(), Lorene::Valeur::set_etat_c_qcq(), Lorene::Mtbl::set_etat_qcq(), Lorene::Scalar::set_etat_qcq(), Lorene::Tbl::set_etat_qcq(), Lorene::Scalar::set_etat_zero(), Lorene::Tbl::set_etat_zero(), Lorene::Scalar::set_spectral_va(), Lorene::Mtbl::t, and Lorene::Tbl::t.

## der_ener_ent() [1/2]

Cmp Lorene::Eos::der_ener_ent | ( | const Cmp & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the logarithmic derivative from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the derivative dln(e)/dln(H) is to be computed.
  l_min | index of the innermost domain is which the coefficient dln(n)/dln(H) is to be computed [default value: 0]; the derivative dln(e)/dln(H) is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  dln(e)/dln(H)

Definition at line 430 of file eos.C.

References calcule(), der_ener_ent_p(), and Lorene::Cmp::get_mp().

## der_ener_ent() [2/2]

Scalar Lorene::Eos::der_ener_ent | ( | const Scalar & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the logarithmic derivative from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the derivative dln(e)/dln(H) is to be computed.
  l_min | index of the innermost domain is which the coefficient dln(n)/dln(H) is to be computed [default value: 0]; the derivative dln(e)/dln(H) is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  dln(e)/dln(H)

Definition at line 440 of file eos.C.

References calcule(), der_ener_ent_p(), and Lorene::Tensor::get_mp().

## der_ener_ent_p()

double Lorene::Eos_poly::der_ener_ent_p | ( | double | ent,
|  | const Param * | par = 0x0 ) const

virtual

Computes the logarithmic derivative from the log-enthalpy.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by Eq. (4)
  par | possible extra parameters of the EOS

Returns
  dln(e)/dln(H)

Implements Lorene::Eos.

Reimplemented in Lorene::Eos_poly_newt.

Definition at line 438 of file eos_poly.C.

References ent_0, Lorene::exp(), gam, gam1, gam1sgamkap, kap, mu_0, Lorene::pow(), rel_mu_0, and unsgam1.

## der_nbar_ent() [1/2]

Cmp Lorene::Eos::der_nbar_ent | ( | const Cmp & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the logarithmic derivative from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the derivative dln(n)/dln(H) is to be computed.
  l_min | index of the innermost domain is which the coefficient dln(n)/dln(H) is to be computed [default value: 0]; the derivative dln(n)/dln(H) is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  dln(n)/dln(H)

Definition at line 407 of file eos.C.

References calcule(), der_nbar_ent_p(), and Lorene::Cmp::get_mp().

## der_nbar_ent() [2/2]

Scalar Lorene::Eos::der_nbar_ent | ( | const Scalar & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the logarithmic derivative from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the derivative dln(n)/dln(H) is to be computed.
  l_min | index of the innermost domain is which the coefficient dln(n)/dln(H) is to be computed [default value: 0]; the derivative dln(n)/dln(H) is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  dln(n)/dln(H)

Definition at line 417 of file eos.C.

References calcule(), der_nbar_ent_p(), and Lorene::Tensor::get_mp().

## der_nbar_ent_p()

double Lorene::Eos_poly::der_nbar_ent_p | ( | double | ent,
|  | const Param * | par = 0x0 ) const

virtual

Computes the logarithmic derivative from the log-enthalpy.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by Eq. (4)
  par | possible extra parameters of the EOS

Returns
  dln(n)/dln(H)

Implements Lorene::Eos.

Reimplemented in Lorene::Eos_poly_newt.

Definition at line 418 of file eos_poly.C.

References ent_0, Lorene::exp(), gam1, and rel_mu_0.

## der_press_ent() [1/2]

Cmp Lorene::Eos::der_press_ent | ( | const Cmp & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the logarithmic derivative from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the derivative dln(p)/dln(H) is to be computed.
  par | possible extra parameters of the EOS
  l_min | index of the innermost domain is which the coefficient dln(n)/dln(H) is to be computed [default value: 0]; the derivative dln(p)/dln(H) is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.

Returns
  dln(p)/dln(H)

Definition at line 452 of file eos.C.

References calcule(), der_press_ent_p(), and Lorene::Cmp::get_mp().

## der_press_ent() [2/2]

Scalar Lorene::Eos::der_press_ent | ( | const Scalar & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the logarithmic derivative from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the derivative dln(p)/dln(H) is to be computed.
  par | possible extra parameters of the EOS
  l_min | index of the innermost domain is which the coefficient dln(n)/dln(H) is to be computed [default value: 0]; the derivative dln(p)/dln(H) is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.

Returns
  dln(p)/dln(H)

Definition at line 462 of file eos.C.

References calcule(), der_press_ent_p(), and Lorene::Tensor::get_mp().

## der_press_ent_p()

double Lorene::Eos_poly::der_press_ent_p | ( | double | ent,
|  | const Param * | par = 0x0 ) const

virtual

Computes the logarithmic derivative from the log-enthalpy.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by Eq. (4)
  par | possible extra parameters of the EOS

Returns
  dln(p)/dln(H)

Implements Lorene::Eos.

Reimplemented in Lorene::Eos_poly_newt.

Definition at line 469 of file eos_poly.C.

References ent_0, Lorene::exp(), gam, gam1, and rel_mu_0.

## ener_ent() [1/2]

Cmp Lorene::Eos::ener_ent | ( | const Cmp & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the total energy density from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the energy density is to be computed.
  l_min | index of the innermost domain is which the energy density is to be computed [default value: 0]; the energy density is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  energy density [unit: ], where

Definition at line 363 of file eos.C.

References calcule(), ener_ent_p(), and Lorene::Cmp::get_mp().

## ener_ent() [2/2]

Scalar Lorene::Eos::ener_ent | ( | const Scalar & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the total energy density from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the energy density is to be computed.
  l_min | index of the innermost domain is which the energy density is to be computed [default value: 0]; the energy density is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  energy density [unit: ], where

Definition at line 373 of file eos.C.

References calcule(), ener_ent_p(), and Lorene::Tensor::get_mp().

## ener_ent_p()

double Lorene::Eos_poly::ener_ent_p | ( | double | ent,
|  | const Param * | par = 0x0 ) const

virtual

Computes the total energy density from the log-enthalpy.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by Eq. (4)
  par | possible extra parameters of the EOS

Returns
  energy density e [unit: ], where

Implements Lorene::Eos.

Reimplemented in Lorene::Eos_poly_newt.

Definition at line 382 of file eos_poly.C.

References ent_0, Lorene::exp(), gam, gam1sgamkap, kap, mu_0, Lorene::pow(), rel_mu_0, and unsgam1.

## eos_from_file() [1/2]

Eos * Lorene::Eos::eos_from_file | ( | FILE * | fich | ) |

static inherited

Construction of an EOS from a binary file.

The file must have been created by the function `sauve(FILE*)` .

Definition at line 177 of file eos_from_file.C.

References Eos(), and Lorene::fread_be().

## eos_from_file() [2/2]

Eos * Lorene::Eos::eos_from_file | ( | ifstream & | fich | ) |

static inherited

Construction of an EOS from a formatted file.

The fist line of the file must start by the EOS number, according to the following conventions:

- 1 = relativistic polytropic EOS (class `Eos_poly` ).
- 2 = Newtonian polytropic EOS (class `Eos_poly_newt` ).
- 3 = Relativistic incompressible EOS (class `Eos_incomp` ).
- 4 = Newtonian incompressible EOS (class `Eos_incomp_newt` ).
- 5 = Strange matter (MIT Bag model)
- 6 = Strange matter (MIT Bag model) with crust
- 10 = SLy4 (Douchin & Haensel 2001)
- 11 = FPS (Friedman-Pandharipande + Skyrme)
- 12 = BPAL12 (Bombaci et al. 1995)
- 13 = AkmalPR (Akmal, Pandharipande & Ravenhall 1998)
- 14 = BBB2 (Baldo, Bombaci & Burgio 1997)
- 15 = BalbN1H1 (Balberg 2000)
- 16 = GlendNH3 (Glendenning 1985, case 3)
- 17 = Compstar (Tabulated EOS for 2010 CompStar school)
- 18 = magnetized (tabulated) equation of state
- 19 = relativistic ideal Fermi gas at zero temperature (class `Eos_Fermi`)
- 100 = Multi-domain EOS (class `MEos` )
- 110 = Multi-polytropic EOS (class `Eos_multi_poly` )
- 120 = Fitted SLy4 (Shibata 2004)
- 121 = Fitted FPS (Shibata 2004)
- 122 = Fitted AkmalPR (Taniguchi 2005)

The second line in the file should contain a name given by the user to the EOS. The following lines should contain the EOS parameters (one parameter per line), in the same order than in the class declaration.

Definition at line 314 of file eos_from_file.C.

References Eos().

## get_gam()

double Lorene::Eos_poly::get_gam | ( |  | ) | const

Returns the adiabatic index (cf. Eq. (3)).

Definition at line 256 of file eos_poly.C.

References gam.

## get_kap()

double Lorene::Eos_poly::get_kap | ( |  | ) | const

Returns the pressure coefficient (cf.

Eq. (3)) [unit: ], where and .

Definition at line 260 of file eos_poly.C.

References kap.

## get_m_0()

double Lorene::Eos_poly::get_m_0 | ( |  | ) | const

Return the individual particule mass (cf.

Eq. (1)) [unit: ].

Definition at line 264 of file eos_poly.C.

References m_0.

## get_mu_0()

double Lorene::Eos_poly::get_mu_0 | ( |  | ) | const

Return the relativistic chemical potential at zero pressure [unit: , with ].

Definition at line 268 of file eos_poly.C.

References mu_0.

## get_name()

const char * Lorene::Eos::get_name | ( |  | ) | const

inherited

Returns the EOS name.

Definition at line 169 of file eos.C.

References name.

## identify()

int Lorene::Eos_poly::identify | ( |  | ) | const

virtual

Returns a number to identify the sub-classe of `Eos` the object belongs to.

Implements Lorene::Eos.

Reimplemented in Lorene::Eos_poly_newt.

Definition at line 129 of file eos_from_file.C.

## nbar_ent() [1/2]

Cmp Lorene::Eos::nbar_ent | ( | const Cmp & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the baryon density field from the log-enthalpy field and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the baryon density is to be computed.
  l_min | index of the innermost domain is which the baryon density is to be computed [default value: 0]; the baryon density is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  baryon density [unit: ]

Definition at line 338 of file eos.C.

References calcule(), Lorene::Cmp::get_mp(), and nbar_ent_p().

## nbar_ent() [2/2]

Scalar Lorene::Eos::nbar_ent | ( | const Scalar & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the baryon density field from the log-enthalpy field and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the baryon density is to be computed.
  l_min | index of the innermost domain is which the baryon density is to be computed [default value: 0]; the baryon density is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  baryon density [unit: ]

Definition at line 348 of file eos.C.

References calcule(), Lorene::Tensor::get_mp(), and nbar_ent_p().

## nbar_ent_p()

double Lorene::Eos_poly::nbar_ent_p | ( | double | ent,
|  | const Param * | par = 0x0 ) const

virtual

Computes the baryon density from the log-enthalpy.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by Eq. (4)
  par | possible extra parameters of the EOS

Returns
  baryon density n [unit: ]

Implements Lorene::Eos.

Reimplemented in Lorene::Eos_poly_newt.

Definition at line 368 of file eos_poly.C.

References ent_0, Lorene::exp(), gam1sgamkap, Lorene::pow(), rel_mu_0, and unsgam1.

## operator!=()

bool Lorene::Eos_poly::operator!= | ( | const Eos & | eos_i | ) | const

virtual

Comparison operator (difference).

Implements Lorene::Eos.

Reimplemented in Lorene::Eos_poly_newt.

Definition at line 324 of file eos_poly.C.

References Lorene::Eos::Eos(), and operator==().

## operator=()

void Lorene::Eos_poly::operator= | ( | const Eos_poly & | eosi | ) |

Assignment to another `Eos_poly`.

Definition at line 224 of file eos_poly.C.

References Eos_poly(), gam, kap, m_0, mu_0, Lorene::Eos::name, set_auxiliary(), and Lorene::Eos::set_name().

## operator==()

bool Lorene::Eos_poly::operator== | ( | const Eos & | eos_i | ) | const

virtual

Comparison operator (egality).

Implements Lorene::Eos.

Reimplemented in Lorene::Eos_poly_newt.

Definition at line 278 of file eos_poly.C.

References Lorene::Eos::Eos(), Eos_poly(), gam, Lorene::Eos::identify(), identify(), kap, m_0, and mu_0.

## operator>>()

ostream & Lorene::Eos_poly::operator>> | ( | ostream & | ost | ) | const

protected virtual

Operator >>.

Implements Lorene::Eos.

Reimplemented in Lorene::Eos_poly_newt.

Definition at line 347 of file eos_poly.C.

References gam, kap, m_0, and mu_0.

## press_ent() [1/2]

Cmp Lorene::Eos::press_ent | ( | const Cmp & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the pressure from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the pressure is to be computed.
  l_min | index of the innermost domain is which the pressure is to be computed [default value: 0]; the pressure is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  pressure [unit: ], where

Definition at line 385 of file eos.C.

References calcule(), Lorene::Cmp::get_mp(), and press_ent_p().

## press_ent() [2/2]

Scalar Lorene::Eos::press_ent | ( | const Scalar & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the pressure from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the pressure is to be computed.
  l_min | index of the innermost domain is which the pressure is to be computed [default value: 0]; the pressure is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  pressure [unit: ], where

Definition at line 395 of file eos.C.

References calcule(), Lorene::Tensor::get_mp(), and press_ent_p().

## press_ent_p()

double Lorene::Eos_poly::press_ent_p | ( | double | ent,
|  | const Param * | par = 0x0 ) const

virtual

Computes the pressure from the log-enthalpy.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by Eq. (4)
  par | possible extra parameters of the EOS

Returns
  pressure p [unit: ], where

Implements Lorene::Eos.

Reimplemented in Lorene::Eos_poly_newt.

Definition at line 400 of file eos_poly.C.

References ent_0, Lorene::exp(), gam, gam1sgamkap, kap, Lorene::pow(), rel_mu_0, and unsgam1.

## sauve()

void Lorene::Eos_poly::sauve | ( | FILE * | fich | ) | const

virtual

Save in a file.

Reimplemented from Lorene::Eos.

Reimplemented in Lorene::Eos_poly_newt.

Definition at line 335 of file eos_poly.C.

References Lorene::fwrite_be(), gam, kap, m_0, mu_0, and Lorene::Eos::sauve().

## set_auxiliary()

void Lorene::Eos_poly::set_auxiliary | ( |  | ) |

protected

Computes the auxiliary quantities `gam1` , `unsgam1` , `gam1sgamkap` from the values of `gam` and `kap`.

Definition at line 242 of file eos_poly.C.

References ent_0, gam, gam1, gam1sgamkap, kap, Lorene::log(), m_0, mu_0, rel_mu_0, and unsgam1.

## set_name()

void Lorene::Eos::set_name | ( | const char * | name_i | ) |

inherited

Sets the EOS name.

Definition at line 163 of file eos.C.

References name.

## Friends And Related Symbol Documentation

## Eos::eos_from_file

Eos * Eos::eos_from_file | ( | FILE * |  | ) |

friend

The construction functions from a file.

References Lorene::Eos::Eos(), and Eos_poly().

## Member Data Documentation

## ent_0

double Lorene::Eos_poly::ent_0

protected

Enthalpy at zero pressure ( ).

Definition at line 790 of file eos.h.

## gam

double Lorene::Eos_poly::gam

protected

Adiabatic index (cf. Eq. (3)).

Definition at line 764 of file eos.h.

## gam1

double Lorene::Eos_poly::gam1

protected

Definition at line 786 of file eos.h.

## gam1sgamkap

double Lorene::Eos_poly::gam1sgamkap

protected

Definition at line 788 of file eos.h.

## kap

double Lorene::Eos_poly::kap

protected

Pressure coefficient (cf.

Eq. (3)) [unit: ], where and .

Definition at line 771 of file eos.h.

## m_0

double Lorene::Eos_poly::m_0

protected

Individual particule mass (cf.

Eq. (1)) [unit: ].

Definition at line 776 of file eos.h.

## mu_0

double Lorene::Eos_poly::mu_0

protected

Relativistic chemical potential at zero pressure [unit: , with ].

(standard value: 1)

Definition at line 782 of file eos.h.

## name

char Lorene::Eos::name[100]

protected inherited

EOS name.

Definition at line 196 of file eos.h.

## rel_mu_0

double Lorene::Eos_poly::rel_mu_0

protected

Definition at line 789 of file eos.h.

## unsgam1

double Lorene::Eos_poly::unsgam1

protected

Definition at line 787 of file eos.h.

The documentation for this class was generated from the following files:

- eos.h
- eos_from_file.C
- eos_poly.C